<?php
/********************************************************************/
/* Copyright (c) 2012-2015 Ynamics SARL                             */
/* 203, rue Michel Carré, 95870 Bezons                              */
/* France                                                           */
/********************************************************************/
/* Copying and use prohibited without prior written authorisation.  */
/********************************************************************/
/* @copyright Copyright (c) 2012-2015, Ynamics SARL                 */
/* @license Proprietary, use prohibited without prior written       */
/*          authorisation                                           */
/* @link http://www.ynamics.com/                                    */
/* @author Mario De Weerd                                           */
/********************************************************************/
class JSNLoggerOptions extends CModel {
    /**
     * Only log messages with a severity equal or higher than this can be sent to the server.
     * optional number (inherited from parent logger)
     */
    public $level;

    /**
     * If not empty, log messages only get processed if this regular expression matches theuser agent string of the browser.
     * optional regular expression (inherited from parent logger)
     */
    public $userAgentRegex;

    /**
     * If not empty, log messages only get processed if this regular expression matches the IP address of the browser. If you use this, be sure to set the IP address via the setOptions method of the JL object.
     * optional regular expression (inherited from parent logger)
     */
    public $ipRegex;

    /**
     * If not empty, log messages are suppressed if they match this regular expression. If an object is being logged, it is converted to a JSON string, which is then matched.
     * optional regular expression (inherited from parent logger)
     */
    public $disallow;

    /**
     * One or more appenders for the logger to send its log messages to. See the examples.
     * optional array of appenders (inherited from parent logger)
     */
    public $appenders;

    /**
     * One or more regular expressions. When a message matches a regular expression, then any subsequent messages matching that same regular expression will be suppressed. See the remarks and examples.
     * optional array of strings (inherited from parent logger)
     */
    public $onceOnly;

    public function attributeNames() {
        return array('level','userAgentRegex','ipRegex','disallow','appenders','onceOnly');
    }

    public function getOptions() {
        $result=array();
        foreach($this->attributeNames() as $attribute) {
            if(isset($this->$attribute)) {
                $result[$attribute]=$this->$attribute;
            }
        }
        return $result;
    }
}
