<?php
/********************************************************************/
/* Copyright (c) 2012-2015 Ynamics SARL                             */
/* 203, rue Michel Carré, 95870 Bezons                              */
/* France                                                           */
/********************************************************************/
/* Copying and use prohibited without prior written authorisation.  */
/********************************************************************/
/* @copyright Copyright (c) 2012-2015, Ynamics SARL                 */
/* @license Proprietary, use prohibited without prior written       */
/*          authorisation                                           */
/* @link http://www.ynamics.com/                                    */
/* @author Mario De Weerd                                           */
/********************************************************************/
class LoggerController extends CController {

   /**
     * Sets up filters to access actions.
     */
    public function filters() {
        // Enable access control.
        return array(
                'accessControl'
        );
    }

    public function accessRules()
    {
        return array(
                array(
                        'allow',
                        'actions'=>array(
                                'jsn'
                        ),
                        'users'=>array('@')),
                array('deny',
                        'expression'=>'1'  // all other cases are denied.
                )
        );
    }

    /**
     * Log message from JavaScript notification.
     */
    public function actionJsn() {
        $body=Yii::app()->getRequest()->getRawBody();
        $data=CJSON::decode($body);
        //$r=$data['r'];
        $lg=$data['lg'];
        if(isset($lg)) {
            //$message='';
            $maxlevel=0;
            foreach($lg as $l) {
                $maxlevel=$l['l'];

                if($maxlevel>=5000) { // 6000=fatal
                    $level=CLogger::LEVEL_ERROR;
                } else if($maxlevel>=4000) {
                    $level=CLogger::LEVEL_WARNING;
                } else if($maxlevel>=3000) {
                    $level=CLogger::LEVEL_INFO;
                } else if($maxlevel>=2000) {
                    $level=CLogger::LEVEL_TRACE;
                } else if($maxlevel>=1000) {
                    $level=CLogger::LEVEL_TRACE;
                }
                if(isset($l['n'])&&$l['n']!=='') {
                    $cat='.'.$l['n'];
                }
                Yii::log($l['m'],$level,'jsn'.$cat);
            }
        }
    }
}
